var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var Forguncy;
(function (Forguncy) {
    var BDMapCellType;
    (function (BDMapCellType_1) {
        var BDMapCellType = (function (_super) {
            __extends(BDMapCellType, _super);
            function BDMapCellType() {
                var _this = _super !== null && _super.apply(this, arguments) || this;
                _this.value = null;
                _this._isMapReadOnly = false;
                return _this;
            }
            BDMapCellType.prototype.createContent = function () {
                var container = $("<div id='" + this.ID + "'></div>");
                var innerContainer = $("<div id='" + this.ID + "inner'style='width:100%;'></div>");
                innerContainer.css("height", this.CellElement.Height - 20);
                var MapDiv = $("<div id='" + this.ID + "map_container' style='width:100%;align:center; height:100%'></div>");
                innerContainer.append(MapDiv);
                container.append(innerContainer);
                return container;
            };
            BDMapCellType.prototype.getOptions = function () {
                var cellTypeMetaData = this.CellElement.CellType;
                var longitude = 116.404;
                if (cellTypeMetaData.Longitude >= -180 && cellTypeMetaData.Longitude <= 180) {
                    longitude = cellTypeMetaData.Longitude;
                }
                var latitude = 39.915;
                if (cellTypeMetaData.Latitude >= -90 && cellTypeMetaData.Latitude <= 90) {
                    latitude = cellTypeMetaData.Latitude;
                }
                var zoom = 15;
                if (cellTypeMetaData.Zoom > 0 && cellTypeMetaData.Zoom < 18) {
                    zoom = cellTypeMetaData.Zoom;
                }
                var position = false;
                if (cellTypeMetaData.Position) {
                    position = cellTypeMetaData.Position;
                }
                var distance = false;
                if (cellTypeMetaData.Distance) {
                    distance = cellTypeMetaData.Distance;
                }
                return {
                    longitude: longitude,
                    latitude: latitude,
                    zoom: zoom,
                    position: position,
                    distance: distance
                };
            };
            BDMapCellType.prototype.onLoad = function () {
                var self = this;
                setTimeout(function () {
                    document.getElementById(self.ID + "map_container").oncontextmenu = function (e) {
                        return false;
                    };
                    self.map = new BMap.Map(document.getElementById(self.ID + "map_container"));
                    self.map.reset();
                    var options = self.getOptions();
                    self.map.centerAndZoom(new BMap.Point(options.longitude, options.latitude), options.zoom);
                    self.addControls();
                    if (options.position) {
                        self.geoLocation(options.longitude, options.latitude);
                    }
                    self.rightClickDistance(options.distance);
                    self.rightClickSetCurrentPointMarker();
                }, 300);
            };
            BDMapCellType.prototype.getValueFromElement = function () {
                return this.value;
            };
            BDMapCellType.prototype.setValueToElement = function (jelement, value) {
                var self = this;
                this.value = value;
                this.commitValue();
                setTimeout(function () {
                    self.setGeoToValue(value);
                }, 300);
            };
            BDMapCellType.prototype.setValueToMap = function (lng, lat) {
                this.value = lng + "," + lat;
                this.commitValue();
            };
            BDMapCellType.prototype.valueIsValid = function (value) {
                try {
                    var temp = value.split(',');
                    if (temp.length === 2 && Number(temp[0]) >= -180 && Number(temp[0]) <= 180 && Number(temp[1]) >= -90 && Number(temp[1]) <= 90) {
                        return true;
                    }
                    else {
                        return false;
                    }
                }
                catch (err) {
                    return false;
                }
            };
            ;
            BDMapCellType.prototype.setGeoToValue = function (value) {
                if (this.valueIsValid(value)) {
                    var temp = value.split(',');
                    this.mapPanTo(Number(temp[0]), Number(temp[1]));
                    this.setMarker(Number(temp[0]), Number(temp[1]));
                }
            };
            BDMapCellType.prototype.rightClickSetCurrentPointMarker = function () {
                var _this = this;
                this.map.addEventListener("rightclick", function (e) {
                    if (!_this._isMapReadOnly) {
                        _this.setMarker(e.point.lng, e.point.lat);
                        _this.mapPanTo(e.point.lng, e.point.lat);
                        _this.setValueToMap(e.point.lng, e.point.lat);
                    }
                });
            };
            BDMapCellType.prototype.rightClickDistance = function (distance) {
                var self = this;
                this.map.addEventListener("rightclick", function (e) {
                    if (distance) {
                        var myDis = new BMapLib.DistanceTool(self.map);
                        myDis.open();
                    }
                });
            };
            BDMapCellType.prototype.addControls = function () {
                this.addGeoCtrl();
                this.map.addControl(new BMap.NavigationControl());
                this.map.addControl(new BMap.ScaleControl());
                this.map.enableScrollWheelZoom(true);
            };
            BDMapCellType.prototype.addGeoCtrl = function () {
                var _this = this;
                var geoCtrl = new BMap.GeolocationControl({
                    showAddressBar: true,
                    enableAutoLocation: true,
                    offset: new BMap.Size(10, 40)
                });
                geoCtrl.addEventListener("locationSuccess", function (e) {
                    if (!_this._isMapReadOnly) {
                        _this.setValueToMap(e.point.lng, e.point.lat);
                    }
                });
                geoCtrl.addEventListener("locationError", function (e) {
                    console.log(e);
                });
                this.map.addControl(geoCtrl);
            };
            BDMapCellType.prototype.geoLocation = function (lng, lat) {
                var self = this;
                if (self.value) {
                    return;
                }
                var geolocation = new BMap.Geolocation();
                geolocation.getCurrentPosition(function (e) {
                    if (self.value) {
                        return;
                    }
                    if (this.getStatus() === BMAP_STATUS_SUCCESS) {
                        self.mapPanTo(e.point.lng, e.point.lat);
                        self.setMarker(e.point.lng, e.point.lat);
                        self.value = e.point.lng + "," + e.point.lat;
                        self.commitValue();
                    }
                    else {
                        self.setMarker(lng, lat);
                        if (self.IsMobile()) {
                            alert("无法获取您的准确定位，请开启定位功能，刷新页面并选择允许定位");
                        }
                    }
                }, { enableHighAccuracy: true });
            };
            BDMapCellType.prototype.IsMobile = function () {
                var system = {
                    win: false,
                    mac: false
                };
                var pc = navigator.platform;
                system.win = pc.indexOf("Win") === 0;
                system.mac = pc.indexOf("Mac") === 0;
                if (system.win || system.mac) {
                    return false;
                }
                else {
                    return true;
                }
            };
            BDMapCellType.prototype.mapPanTo = function (lng, lat) {
                var toPoint = new BMap.Point(lng, lat);
                this.map.panTo(toPoint, true);
            };
            BDMapCellType.prototype.setMarker = function (lng, lat) {
                this.map.clearOverlays();
                var markerPoint = new BMap.Point(lng, lat);
                var mk = new BMap.Marker(markerPoint);
                this.map.addOverlay(mk);
            };
            BDMapCellType.prototype.setReadOnly = function (value) {
                _super.prototype.setReadOnly.call(this, value);
                this._isMapReadOnly = value;
            };
            return BDMapCellType;
        }(Forguncy.Plugin.CellTypeBase));
        BDMapCellType_1.BDMapCellType = BDMapCellType;
    })(BDMapCellType = Forguncy.BDMapCellType || (Forguncy.BDMapCellType = {}));
})(Forguncy || (Forguncy = {}));
Forguncy.Plugin.CellTypeHelper.registerCellType("BDMapCellType.BDMapCellType, BDMapCellType", Forguncy.BDMapCellType.BDMapCellType);
